"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _uiElements = require("@instructure/ui-elements");

var _uiThemeable = require("@instructure/ui-themeable");

var _Edit = _interopRequireDefault(require("../Edit"));

var _Show = _interopRequireDefault(require("../Show"));

var _Take = _interopRequireDefault(require("../Take"));

var _Result = _interopRequireDefault(require("../Result"));

var _defaultTheme = _interopRequireDefault(require("../../common/example/defaultTheme"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'egxol',
  template: function template(theme) {
    return "\n\n.egxol_dXOl{flex:1;padding:".concat(theme.panelPadding || 'inherit', "}\n\n.egxol_qOas{display:flex}");
  },
  'panel': 'egxol_dXOl',
  'row': 'egxol_qOas'
};

var noop = function noop() {};
/**
---
category: Categorization
---
  Categorization Example.

  ```jsx_example
    const WrappedExample = DragDropContext(HTML5Backend)(CategorizationExample);

    <SettingsSwitcher locales={LOCALES}>
      <WrappedExample />
    </SettingsSwitcher>
  ```
**/


var _ref =
/*#__PURE__*/
_react.default.createElement(_uiElements.Heading, {
  level: "h2"
}, "Edit");

var _ref2 =
/*#__PURE__*/
_react.default.createElement(_uiElements.Heading, {
  level: "h2"
}, "Show");

var _ref3 =
/*#__PURE__*/
_react.default.createElement(_uiElements.Heading, {
  level: "h2"
}, "Take");

var _ref4 =
/*#__PURE__*/
_react.default.createElement(_uiElements.Heading, {
  level: "h2"
}, "Result");

var CategorizationExample = (_dec = (0, _uiThemeable.themeable)(_defaultTheme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(CategorizationExample, _Component);

  function CategorizationExample(props) {
    var _this;

    (0, _classCallCheck2.default)(this, CategorizationExample);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(CategorizationExample).call(this));

    _this.handleChangeItemState = function (itemState) {
      var newState = {};

      if (itemState.scoringData) {
        newState.userResponse = _this.transformUserResponse(itemState.scoringData);
      }

      var updatedState = Object.assign({}, itemState, newState);

      _this.setState(updatedState);
    };

    _this.handleResponseUpdate = function (userResponse) {
      _this.setState({
        userResponse: {
          value: userResponse
        }
      });
    };

    _this.state = {};

    if (props.useDefaultData) {
      Object.assign(_this.state, {
        itemBody: 'Match the name of the celestial body on the left with its correct classification:',
        interactionData: {
          categories: {
            category_uuid1: {
              id: 'category_uuid1',
              itemBody: 'Planet'
            },
            category_uuid2: {
              id: 'category_uuid2',
              itemBody: 'Moon'
            }
          },
          distractors: {
            answer_uuid3: {
              id: 'answer_uuid3',
              itemBody: 'Mars'
            },
            answer_uuid4: {
              id: 'answer_uuid4',
              itemBody: 'Europa'
            },
            answer_uuid5: {
              id: 'answer_uuid5',
              itemBody: 'Venus'
            },
            answer_uuid6: {
              id: 'answer_uuid6',
              itemBody: 'Phobos'
            },
            answer_uuid7: {
              id: 'answer_uuid7',
              itemBody: 'Deimos'
            },
            answer_uuid8: {
              id: 'answer_uuid8',
              itemBody: 'Jupiter'
            },
            answer_uuid9: {
              id: 'answer_uuid9',
              itemBody: 'America'
            },
            answer_uuid10: {
              id: 'answer_uuid10',
              itemBody: 'Asia'
            }
          }
        },
        scoringData: {
          value: [{
            id: 'category_uuid1',
            scoringAlgorithm: 'AllOrNothing',
            scoringData: {
              value: ['answer_uuid3', 'answer_uuid5', 'answer_uuid8']
            }
          }, {
            id: 'category_uuid2',
            scoringAlgorithm: 'AllOrNothing',
            scoringData: {
              value: ['answer_uuid4', 'answer_uuid6', 'answer_uuid7']
            }
          }]
        },
        userResponse: {
          value: [{
            id: 'category_uuid1',
            value: ['answer_uuid3', 'answer_uuid5', 'answer_uuid8'],
            type: 'ArrayText'
          }, {
            id: 'category_uuid2',
            value: ['answer_uuid4', 'answer_uuid6', 'answer_uuid7'],
            type: 'ArrayText'
          }]
        }
      });
      _this.state.scoredData = _this.transformScoredData();
    }

    return _this;
  }

  (0, _createClass2.default)(CategorizationExample, [{
    key: "getResultScore",
    value: function getResultScore(scoringData, categoryId, answerId) {
      var scoringDataCategory = scoringData.value.find(function (category) {
        return category.id === categoryId;
      });
      return scoringDataCategory.scoringData.value.includes(answerId) ? 1 : 0;
    }
  }, {
    key: "transformScoredData",
    value: function transformScoredData() {
      var _this2 = this;

      var newValues = {};
      this.state.userResponse.value.forEach(function (userResponseValue) {
        var obj = {};
        Object.keys(_this2.state.interactionData.distractors).forEach(function (answerId) {
          obj[answerId] = {
            resultScore: _this2.getResultScore(_this2.state.scoringData, userResponseValue.id, answerId),
            userResponded: userResponseValue.value.includes(answerId)
          };
        });
        newValues[userResponseValue.id] = {
          value: obj
        };
      });
      return {
        value: newValues
      };
    }
  }, {
    key: "transformUserResponse",
    value: function transformUserResponse(scoringData) {
      var userResponse = scoringData.value.map(function (item) {
        return {
          id: item.id,
          value: item.scoringData.value
        };
      });
      return {
        value: userResponse
      };
    }
  }, {
    key: "renderEdit",
    value: function renderEdit() {
      return _react.default.createElement("div", {
        title: "edit"
      }, _ref, _react.default.createElement(_Edit.default, {
        changeItemState: this.handleChangeItemState,
        interactionData: this.state.interactionData,
        itemBody: this.state.itemBody,
        itemId: this.state.itemId,
        scoringData: this.state.scoringData
      }));
    }
  }, {
    key: "renderShow",
    value: function renderShow() {
      return _react.default.createElement("div", {
        title: "show"
      }, _ref2, _react.default.createElement(_Show.default, {
        interactionData: this.state.interactionData,
        itemBody: this.state.itemBody,
        scoringData: this.state.scoringData
      }));
    }
  }, {
    key: "renderTake",
    value: function renderTake() {
      return _react.default.createElement("div", {
        title: "take"
      }, _ref3, _react.default.createElement(_Take.default, {
        interactionData: this.state.interactionData,
        itemBody: this.state.itemBody,
        userResponse: this.state.userResponse,
        handleResponseUpdate: this.handleResponseUpdate,
        notifyScreenreader: noop
      }));
    }
  }, {
    key: "renderResult",
    value: function renderResult() {
      return _react.default.createElement("div", {
        title: "result"
      }, _ref4, _react.default.createElement(_Result.default, {
        interactionData: this.state.interactionData,
        itemBody: this.state.itemBody,
        scoredData: this.transformScoredData()
      }));
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", null, _react.default.createElement("div", {
        className: styles.row
      }, _react.default.createElement("div", {
        className: styles.panel
      }, this.renderEdit()), _react.default.createElement("div", {
        className: styles.panel
      }, this.renderShow())), _react.default.createElement("div", {
        className: styles.row
      }, _react.default.createElement("div", {
        className: styles.panel
      }, this.renderTake()), _react.default.createElement("div", {
        className: styles.panel
      }, this.renderResult())));
    }
  }]);
  CategorizationExample.displayName = "CategorizationExample";
  return CategorizationExample;
}(_react.Component), _class2.propTypes = {
  useDefaultData: _propTypes.default.bool
}, _class2.defaultProps = {
  useDefaultData: true
}, _temp)) || _class);
exports.default = CategorizationExample;