"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _partial = _interopRequireDefault(require("lodash/partial"));

var _uiA11y = require("@instructure/ui-a11y");

var _uiForms = require("@instructure/ui-forms");

var _quizRce = require("@instructure/quiz-rce");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

// this exists as its own component to
// get the benefits of componentDidMount
var AnswerInput =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(AnswerInput, _Component);

  function AnswerInput() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, AnswerInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(AnswerInput)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.focus = function () {
      _this.answerInput.focus();
    };

    _this.handleRef = function (node) {
      _this.answerInput = node;
    };

    _this.handleTextChange = function (event) {
      _this.props.onChangeHandler(_this.props.id, event, {
        editorContent: event.target.value
      });
    };

    return _this;
  }

  (0, _createClass2.default)(AnswerInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.focusOnMount) {
        this.answerInput.focus();
      }
    }
  }, {
    key: "renderTextInput",
    value: function renderTextInput() {
      return _react.default.createElement(_uiForms.TextInput, {
        disabled: this.props.disabled,
        id: this.choiceId,
        name: this.choiceId,
        messages: this.props.errors,
        ref: this.handleRef,
        label: _react.default.createElement(_uiA11y.ScreenReaderContent, null, this.screenReaderText),
        onChange: this.handleTextChange,
        placeholder: this.placeholder,
        type: "text",
        value: this.props.itemBody
      });
    }
  }, {
    key: "guardedOnChange",
    value: function guardedOnChange(handler) {
      return function (id, evt) {
        if (evt.originalEvent && evt.originalEvent.command === 'mceNewDocument') {
          return;
        }

        for (var _len2 = arguments.length, theArgs = new Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
          theArgs[_key2 - 2] = arguments[_key2];
        }

        handler.apply(void 0, [id, evt].concat(theArgs));
      };
    }
  }, {
    key: "renderRichContentInput",
    value: function renderRichContentInput() {
      return _react.default.createElement("div", null, _react.default.createElement("label", {
        htmlFor: this.choiceId
      }, _react.default.createElement(_uiA11y.ScreenReaderContent, null, this.screenReaderText)), _react.default.createElement(_quizRce.RichContentInput, {
        actsAsInput: true,
        defaultContent: this.props.itemBody,
        disabled: this.props.disabled,
        readOnly: this.props.readOnly,
        id: this.choiceId,
        label: "",
        messages: this.props.errors,
        name: this.choiceId,
        onChange: (0, _partial.default)(this.guardedOnChange(this.props.onChangeHandler), this.props.id),
        onModalClose: this.props.onModalClose,
        onModalOpen: this.props.onModalOpen,
        openImportModal: this.props.openImportModal,
        placeholder: this.placeholder,
        renderImportModal: this.props.renderImportModal,
        ref: this.handleRef,
        textareaId: this.choiceId,
        type: "text",
        focusOnMount: this.props.focusOnMount
      }));
    }
  }, {
    key: "render",
    value: function render() {
      if (this.props.noRCE) {
        return this.renderTextInput();
      }

      return this.renderRichContentInput();
    }
  }, {
    key: "screenReaderText",
    get: function get() {
      return this.props.screenReaderText || (0, _formatMessage.default)('Answer Value');
    }
  }, {
    key: "placeholder",
    get: function get() {
      return this.props.placeholder || (0, _formatMessage.default)('Type an answer');
    }
  }, {
    key: "choiceId",
    get: function get() {
      return "".concat(this.props.parentType, "_").concat(this.props.id, "_answer_input");
    }
  }]);
  AnswerInput.displayName = "AnswerInput";
  return AnswerInput;
}(_react.Component);

exports.default = AnswerInput;
AnswerInput.propTypes = {
  disabled: _propTypes.default.bool,
  onChangeHandler: _propTypes.default.func.isRequired,
  id: _propTypes.default.string.isRequired,
  itemBody: _propTypes.default.string.isRequired,
  errors: _propTypes.default.array,
  onModalClose: _propTypes.default.func,
  onModalOpen: _propTypes.default.func,
  placeholder: _propTypes.default.string,
  screenReaderText: _propTypes.default.string,
  focusOnMount: _propTypes.default.bool,
  noRCE: _propTypes.default.bool,
  parentType: _propTypes.default.string,
  openImportModal: _propTypes.default.func,
  readOnly: _propTypes.default.bool,
  renderImportModal: _propTypes.default.func
};
AnswerInput.defaultProps = {
  disabled: false,
  errors: [],
  screenReaderText: null,
  parentType: '',
  placeholder: null,
  noRCE: false,
  readOnly: false,
  onModalClose: void 0,
  onModalOpen: void 0,
  focusOnMount: void 0,
  openImportModal: void 0,
  renderImportModal: void 0
};