"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _uiElements = require("@instructure/ui-elements");

var _uiA11y = require("@instructure/ui-a11y");

var _uiLayout = require("@instructure/ui-layout");

var _quizNumberInput = _interopRequireDefault(require("@instructure/quiz-number-input"));

var _uiThemeable = require("@instructure/ui-themeable");

var _uuid = require("uuid");

var _theme = _interopRequireDefault(require("./theme"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'JPEDC',
  template: function template(theme) {
    return "\n\n.JPEDC_epLb{align-items:flex-start;display:flex;justify-content:center;padding:".concat(theme.answerPointValuePadding || 'inherit', "}");
  },
  'answerPointValue': 'JPEDC_epLb'
};

function pointsAsFloat(pointsString) {
  return parseFloat(pointsString) || 0;
}

function countDecimals(normalizedPointsString) {
  if (!normalizedPointsString) return 0; // eslint-disable-next-line no-unused-vars

  var _normalizedPointsStri = normalizedPointsString.split('.'),
      _normalizedPointsStri2 = (0, _slicedToArray2.default)(_normalizedPointsStri, 2),
      _ = _normalizedPointsStri2[0],
      decimals = _normalizedPointsStri2[1];

  return decimals ? decimals.length : 0;
}

var AnswerPoints = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(AnswerPoints, _Component);

  function AnswerPoints() {
    var _this;

    (0, _classCallCheck2.default)(this, AnswerPoints);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(AnswerPoints).apply(this, arguments));

    _this.handleChange = function (event, points, normalizedPoints) {
      // do not allow more than 3 decimals
      if (_this.props.onAnswerPointsChange && countDecimals(normalizedPoints) <= 3) {
        var pointsFloat = pointsAsFloat(normalizedPoints);

        if (pointsFloat !== _this.props.answerPoints) {
          _this.props.onAnswerPointsChange(pointsFloat);
        }

        _this.setState({
          points: points,
          normalizedPoints: normalizedPoints
        });
      }
    };

    _this.handleBlur = function (event) {
      if (!_this.state.normalizedPoints) {
        _this.setState({
          points: '0'
        });
      }
    };

    var answerPoints = _this.props.answerPoints;

    var _points = answerPoints == null ? '' : answerPoints;

    _this.state = {
      points: _points,
      normalizedPoints: _points
    };
    _this.numberInputLabelId = (0, _uuid.v4)();
    return _this;
  }

  (0, _createClass2.default)(AnswerPoints, [{
    key: "render",
    value: function render() {
      return _react.default.createElement("span", {
        className: styles.answerPointValue
      }, _react.default.createElement(_quizNumberInput.default, {
        "aria-describedby": this.numberInputLabelId,
        label: _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Points Possible')),
        onChange: this.handleChange,
        onBlur: this.handleBlur,
        value: this.state.points,
        name: this.props.name,
        width: "6.1rem"
        /* wide enough to fit 3 decimal places (i.e. 8.888) */

      }), _react.default.createElement(_uiLayout.View, {
        padding: "small"
      }, _react.default.createElement(_uiElements.Text, {
        id: this.numberInputLabelId,
        color: "primary",
        size: "small"
      }, (0, _formatMessage.default)('Pts'))));
    }
  }]);
  AnswerPoints.displayName = "AnswerPoints";
  return AnswerPoints;
}(_react.Component), _class2.propTypes = {
  name: _propTypes.default.string,
  answerPoints: _propTypes.default.number,
  onAnswerPointsChange: _propTypes.default.func
}, _class2.defaultProps = {
  name: void 0,
  answerPoints: void 0,
  onAnswerPointsChange: void 0
}, _temp)) || _class);
exports.default = AnswerPoints;