"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _uiLayout = require("@instructure/ui-layout");

var _uiForms = require("@instructure/ui-forms");

var _uiA11y = require("@instructure/ui-a11y");

var _uiTestable = _interopRequireDefault(require("@instructure/ui-testable"));

var _dec, _class, _class2, _temp;

var CalculatorOption = (_dec = (0, _uiTestable.default)(), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(CalculatorOption, _Component);

  function CalculatorOption() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, CalculatorOption);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(CalculatorOption)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.handleCheckboxChange = function (event) {
      var value = event.target.checked ? 'basic' : 'none';

      _this.props.onChange(event, value);
    };

    return _this;
  }

  (0, _createClass2.default)(CalculatorOption, [{
    key: "isChecked",
    value: function isChecked(value) {
      return ['basic', 'scientific'].includes(value);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          disabled = _this$props.disabled,
          onChange = _this$props.onChange,
          value = _this$props.value;
      var checked = this.isChecked(value);
      return _react.default.createElement("div", null, _react.default.createElement(_uiForms.Checkbox, {
        disabled: disabled,
        label: (0, _formatMessage.default)('Show on-screen calculator'),
        onChange: this.handleCheckboxChange,
        value: "none",
        checked: checked
      }), checked && _react.default.createElement(_uiLayout.View, {
        as: "div",
        margin: "small 0 0 medium"
      }, _react.default.createElement(_uiForms.RadioInputGroup, {
        disabled: disabled,
        name: "calculator",
        onChange: onChange,
        value: value,
        description: _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Calculator type'))
      }, _react.default.createElement(_uiForms.RadioInput, {
        label: (0, _formatMessage.default)('Basic calculator'),
        value: "basic"
      }), _react.default.createElement(_uiForms.RadioInput, {
        label: (0, _formatMessage.default)('Scientific calculator'),
        value: "scientific"
      }))));
    }
  }]);
  CalculatorOption.displayName = "CalculatorOption";
  return CalculatorOption;
}(_react.Component), _class2.propTypes = {
  disabled: _propTypes.default.bool,
  onChange: _propTypes.default.func.isRequired,
  value: _propTypes.default.oneOf(['none', 'basic', 'scientific']).isRequired
}, _class2.defaultProps = {
  disabled: false
}, _temp)) || _class);
exports.default = CalculatorOption;