"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _striptags = _interopRequireDefault(require("striptags"));

var _uiA11y = require("@instructure/ui-a11y");

var _uiThemeable = require("@instructure/ui-themeable");

var _quizRce = require("@instructure/quiz-rce");

var _uiButtons = require("@instructure/ui-buttons");

var _uiElements = require("@instructure/ui-elements");

var _AnswerInput = _interopRequireDefault(require("../AnswerInput"));

var _AnswerPoints = _interopRequireDefault(require("../AnswerPoints"));

var _LockChoiceButton = _interopRequireDefault(require("../LockChoiceButton"));

var _RemoveChoiceButton = _interopRequireDefault(require("../RemoveChoiceButton"));

var _EditAnswerFeedbackButton = _interopRequireDefault(require("../EditAnswerFeedbackButton"));

var _theme = _interopRequireDefault(require("./theme"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'cKrRp',
  template: function template(theme) {
    return "\n\n.cKrRp_eSAa{color:".concat(theme.userInputColor || 'inherit', ";padding:").concat(theme.userInputPadding || 'inherit', "}\n\n.cKrRp_dEex{display:grid;grid-template-columns:1fr auto;grid-template-rows:auto auto;width:100%}\n\n.cKrRp_baGb{display:flex;grid-column:2;grid-row:1/3}\n\n.cKrRp_ckUO{display:flex;justify-content:flex-end}");
  },
  'userInput': 'cKrRp_eSAa',
  'choiceInputWrapper': 'cKrRp_dEex',
  'choiceIcons': 'cKrRp_baGb',
  'doneButton': 'cKrRp_ckUO'
};
var ChoiceInput = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(ChoiceInput, _Component);

  function ChoiceInput() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, ChoiceInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(ChoiceInput)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.removeChoicebutton = null;
    _this.answerInput = null;
    _this.lockChoiceButton = null;
    _this.editAnswerFeedbackButton = null;
    _this.answerFeedbackInput = null;

    _this.focusOnRemoveChoice = function () {
      _this.removeChoicebutton.focus();
    };

    _this.focusOnAnswerInput = function () {
      _this.answerInput.focus();
    };

    _this.focusOnAnswerFeedback = function () {
      if (_this.editAnswerFeedbackButton) {
        _this.editAnswerFeedbackButton.focus();
      }
    };

    _this.focusLast = function () {
      if (_this.props.shouldRenderRemoveChoice) {
        _this.removeChoicebutton.focus();
      } else if (_this.props.showLock) {
        _this.lockChoiceButton.focus();
      } else {
        _this.answerInput.focus();
      }
    };

    _this.focusAndCloseRCE = function () {
      _this.focusOnAnswerFeedback();

      _this.props.handleAnswerFeedbackToggle(_this.props.id);
    };

    _this.handleEditAnswerFeedbackRef = function (node) {
      _this.editAnswerFeedbackButton = node;
    };

    _this.handleRemoveChoiceButtonRef = function (node) {
      _this.removeChoicebutton = node;
    };

    _this.handleAnswerInputRef = function (node) {
      _this.answerInput = node;
    };

    _this.handleLockButtonRef = function (node) {
      _this.lockChoiceButton = node;
    };

    _this.handleRichContentChange = function (event, rceContent) {
      var editorContent = rceContent.editorContent;

      if (editorContent === void 0) {
        return;
      }

      _this.props.changeItemState({
        answerFeedback: Object.assign({}, _this.props.answerFeedback, (0, _defineProperty2.default)({}, _this.props.id, editorContent))
      });
    };

    return _this;
  }

  (0, _createClass2.default)(ChoiceInput, [{
    key: "renderLockButton",
    // ===========
    //   RENDERS
    // ===========
    value: function renderLockButton() {
      var screenReaderText = this.props.isLocked ? (0, _formatMessage.default)('Unlock Distractor Position: {choice}', {
        choice: (0, _striptags.default)(this.props.itemBody)
      }) : (0, _formatMessage.default)('Lock Distractor Position: {choice}', {
        choice: (0, _striptags.default)(this.props.itemBody)
      });
      return _react.default.createElement(_LockChoiceButton.default, {
        ref: this.handleLockButtonRef,
        choiceId: this.props.id,
        isLocked: this.props.isLocked,
        onToggle: this.props.toggleChoiceLocked,
        disabled: this.props.disabledFields.includes('lockChoiceButton'),
        screenReaderText: screenReaderText
      });
    }
  }, {
    key: "renderRemoveChoiceButton",
    value: function renderRemoveChoiceButton() {
      var text = this.props.removeButtonScreenReaderText || (0, _formatMessage.default)('Remove Distractor: {choice}', {
        choice: (0, _striptags.default)(this.props.itemBody)
      });
      return _react.default.createElement(_RemoveChoiceButton.default, {
        ref: this.handleRemoveChoiceButtonRef,
        choiceId: this.props.id,
        onRemoveChoice: this.props.onRemoveChoice,
        screenReaderText: text
      });
    }
  }, {
    key: "renderEditAnswerFeedbackButton",
    value: function renderEditAnswerFeedbackButton() {
      return _react.default.createElement(_EditAnswerFeedbackButton.default, {
        ref: this.handleEditAnswerFeedbackRef,
        choiceId: this.props.id,
        onEditChoiceFeedback: this.props.handleAnswerFeedbackToggle,
        iconFilled: !!this.props.answerFeedback[this.props.id],
        itemBody: this.props.itemBody,
        expanded: this.props.expanded,
        notifyScreenreader: this.props.notifyScreenreader
      });
    }
  }, {
    key: "renderAnswerPoints",
    value: function renderAnswerPoints() {
      return _react.default.createElement(_AnswerPoints.default, {
        name: "".concat(this.props.id, "_answerPoints") // eslint-disable-line react/jsx-no-literals
        ,
        answerPoints: this.props.answerPoints,
        onAnswerPointsChange: this.props.onAnswerPointsChange
      });
    }
  }, {
    key: "renderExpandingRichContentInput",
    value: function renderExpandingRichContentInput() {
      var rceId = "".concat(this.props.id, "_answer_feedback");
      return _react.default.createElement("div", {
        "data-automation": "sdk-choice-edit-answer-feedback-rce"
      }, _react.default.createElement(_uiElements.Heading, {
        level: "h4",
        as: "h3",
        margin: "medium 0 xxx-small"
      }, (0, _formatMessage.default)('Answer Feedback')), _react.default.createElement(_quizRce.RichContentInput, {
        label: _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Edit choice feedback')),
        onChange: this.handleRichContentChange,
        onKeyUp: this.handleRichContentChange,
        onModalClose: this.props.onModalClose,
        onModalOpen: this.props.onModalOpen,
        openImportModal: this.props.openImportModal,
        placeholder: (0, _formatMessage.default)('Edit choice feedback'),
        renderImportModal: this.props.renderImportModal,
        defaultContent: this.props.answerFeedback[this.props.id],
        textareaId: rceId
      }), _react.default.createElement("div", {
        className: styles.doneButton,
        "data-automation": "sdk-edit-answer-feedback-done-button"
      }, _react.default.createElement(_uiButtons.Button, {
        onClick: this.focusAndCloseRCE,
        margin: "small"
      }, (0, _formatMessage.default)('Done'))));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          itemBody = _this$props.itemBody,
          errors = _this$props.errors,
          id = _this$props.id,
          shouldRenderAnswerPoints = _this$props.shouldRenderAnswerPoints,
          showLock = _this$props.showLock,
          shouldRenderRemoveChoice = _this$props.shouldRenderRemoveChoice,
          shouldRenderAnswerFeedback = _this$props.shouldRenderAnswerFeedback;
      return _react.default.createElement("div", {
        className: styles.choiceInputWrapper
      }, _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Answer Value {itemBody}', {
        itemBody: (0, _striptags.default)(itemBody)
      })), _react.default.createElement("div", {
        className: styles.userInput
      }, _react.default.createElement(_AnswerInput.default, {
        disabled: this.props.disabledFields.includes('answerInput'),
        errors: errors,
        id: id,
        itemBody: itemBody,
        focusOnMount: this.props.focusOnMount,
        noRCE: this.props.noRCE,
        onChangeHandler: this.props.onInputChange,
        onModalClose: this.props.onModalClose,
        onModalOpen: this.props.onModalOpen,
        openImportModal: this.props.openImportModal,
        parentType: this.props.parentType,
        readOnly: this.props.readOnlyFields.includes('answerInput'),
        ref: this.handleAnswerInputRef,
        renderImportModal: this.props.renderImportModal
      })), _react.default.createElement("div", {
        className: styles.choiceIcons
      }, shouldRenderAnswerPoints && this.renderAnswerPoints(), showLock && this.renderLockButton(), _react.default.createElement("div", {
        "data-automation": "sdk-choice-edit-answer-feedback-button"
      }, shouldRenderAnswerFeedback && this.renderEditAnswerFeedbackButton()), shouldRenderRemoveChoice && this.renderRemoveChoiceButton()), this.props.expanded && shouldRenderAnswerFeedback && this.renderExpandingRichContentInput());
    }
  }]);
  ChoiceInput.displayName = "ChoiceInput";
  return ChoiceInput;
}(_react.Component), _class2.propTypes = {
  answerFeedback: _propTypes.default.objectOf(_quizRce.RichContentInput.propTypes.defaultContent),
  answerPoints: _propTypes.default.number,
  changeItemState: _propTypes.default.func,
  disabledFields: _propTypes.default.arrayOf(_propTypes.default.string),
  errors: _propTypes.default.array,
  expanded: _propTypes.default.bool,
  focusOnMount: _propTypes.default.bool,
  handleAnswerFeedbackToggle: _propTypes.default.func,
  id: _propTypes.default.string.isRequired,
  isLocked: _propTypes.default.bool,
  itemBody: _propTypes.default.string.isRequired,
  noRCE: _propTypes.default.bool,
  notifyScreenreader: _propTypes.default.func.isRequired,
  onAnswerPointsChange: _propTypes.default.func,
  onInputChange: _propTypes.default.func.isRequired,
  onModalClose: _propTypes.default.func,
  onModalOpen: _propTypes.default.func,
  onRemoveChoice: _propTypes.default.func,
  parentType: _propTypes.default.string,
  shouldRenderAnswerPoints: _propTypes.default.bool,
  shouldRenderAnswerFeedback: _propTypes.default.bool,
  shouldRenderRemoveChoice: _propTypes.default.bool,
  showLock: _propTypes.default.bool,
  toggleChoiceLocked: _propTypes.default.func,
  openImportModal: _propTypes.default.func,
  readOnlyFields: _propTypes.default.arrayOf(_propTypes.default.string),
  renderImportModal: _propTypes.default.func,
  removeButtonScreenReaderText: _propTypes.default.string
}, _class2.defaultProps = {
  answerFeedback: {},
  changeItemState: function changeItemState() {},
  disabledFields: [],
  errors: [],
  expanded: false,
  focusOnMount: false,
  handleAnswerFeedbackToggle: function handleAnswerFeedbackToggle() {},
  noRCE: false,
  parentType: '',
  readOnlyFields: [],
  shouldRenderAnswerPoints: false,
  shouldRenderAnswerFeedback: false,
  shouldRenderRemoveChoice: false,
  answerPoints: void 0,
  isLocked: void 0,
  onAnswerPointsChange: void 0,
  onModalClose: void 0,
  onModalOpen: void 0,
  onRemoveChoice: void 0,
  showLock: void 0,
  toggleChoiceLocked: void 0,
  openImportModal: void 0,
  renderImportModal: void 0,
  removeButtonScreenReaderText: void 0
}, _temp)) || _class);
exports.default = ChoiceInput;