"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _pick = _interopRequireDefault(require("lodash/fp/pick"));

var _platform = _interopRequireDefault(require("platform"));

var _classnames = _interopRequireDefault(require("classnames"));

var _uiLayout = require("@instructure/ui-layout");

var _uiThemeable = require("@instructure/ui-themeable");

var _theme = _interopRequireDefault(require("./theme"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'PBaNu',
  template: function template(theme) {
    return "\n\n.PBaNu_bGBk{color:".concat(theme.fontColor || 'inherit', ";font-family:").concat(theme.fontFamily || 'inherit', "}");
  },
  'root': 'PBaNu_bGBk'
};
var BACKSPACE_KEY = 'Backspace';
var ENTER_KEY = 'Enter';
var KEYS = ['b', 'i', 'u'];

function shouldStopEffect(e) {
  return (e.metaKey || e.ctrlKey) && KEYS.includes(e.key);
}

var ContentEditable = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(ContentEditable, _Component);

  function ContentEditable() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, ContentEditable);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(ContentEditable)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.span = null;

    _this.handleKeyPress = function (e) {
      // prevent <br> from being created in contentEditable
      if (e.key === ENTER_KEY) {
        e.preventDefault();
      }

      _this.props.onKeyDown(e);
    };

    _this.handleKeyUp = function (e) {
      if (_this.props.enableFormatting) {
        return;
      }

      if (shouldStopEffect(e)) {
        e.preventDefault();
        e.stopPropagation();
      } // IE11 spans don't trigger onInput on every keystroke, so use
      // keyUp here instead


      if (_platform.default.name === 'IE' && _platform.default.version === '11.0') {
        _this.handleInput(e);
      }
    };

    _this.handleKeyDown = function (e) {
      if (e.key !== BACKSPACE_KEY) return;
      var selection = window.getSelection();
      if (selection.rangeCount !== 1) return;
      var range = selection.getRangeAt(0);

      if (range.commonAncestorContainer.parentNode === _this.span && range.startOffset === 1 && range.endOffset === 1) {
        e.preventDefault();
        _this.span.innerText = _this.span.innerText.slice(1);

        _this.handleInput(e);
      }
    };

    _this.handleInput = function (e) {
      _this.props.onChange(e);

      _this.props.onInput(e);
    };

    _this.handleBlur = function (e) {
      _this.props.onChange(e);

      _this.props.onBlur(e);
    };

    _this.handleFocus = function (e) {
      _this.props.onChange(e);

      _this.props.onFocus(e);
    };

    _this.handleRef = function (node) {
      _this.span = node;
    };

    return _this;
  }

  (0, _createClass2.default)(ContentEditable, [{
    key: "shouldComponentUpdate",
    // see the stackoverflow question cited at the top of this file for
    // an explanation of why the content is managed through lifecylce functions
    // instead of just rendering with dangerouslySetInnerHTML (or as children).
    value: function shouldComponentUpdate(nextProps) {
      return nextProps.content !== this.span.innerText;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.span.innerText = this.props.content;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.props.content !== this.span.innerText) {
        this.span.innerText = this.props.content;
      }
    }
  }, {
    key: "focusAndSetCursorOnPosition",
    value: function focusAndSetCursorOnPosition(position) {
      if (!this.span) {
        return;
      }

      this.span.focus();
      var range = document.createRange();
      var sel = window.getSelection();
      var textNode = this.span.childNodes[0];
      range.setStart(textNode, 0);
      range.setEnd(textNode, position);
      sel.removeAllRanges();
      sel.addRange(range);
      sel.collapseToEnd();
    }
  }, {
    key: "render",
    value: function render() {
      var props = (0, _pick.default)(['id', 'onMouseUp', 'onKeyUp', 'onPaste', 'placeholder'], this.props);

      var classes = _classnames.default.apply(void 0, [styles.root].concat((0, _toConsumableArray2.default)(this.props.className.split(' '))));

      var labelId = "ce-label-for-".concat(this.props.id);
      return _react.default.createElement(_uiLayout.View, null, _react.default.createElement("label", {
        id: labelId,
        htmlFor: this.props.id
      }, this.props.label), _react.default.createElement("span", Object.assign({
        "aria-labelledby": labelId
      }, props, {
        className: classes,
        ref: this.handleRef,
        onInput: this.handleInput,
        onBlur: this.handleBlur,
        onFocus: this.handleFocus,
        onKeyPress: this.handleKeyPress,
        onKeyUp: this.handleKeyUp,
        onKeyDown: this.handleKeyDown,
        role: "textbox",
        tabIndex: "0",
        contentEditable: !this.props.disabled
      })));
    }
  }]);
  ContentEditable.displayName = "ContentEditable";
  return ContentEditable;
}(_react.Component), _class2.propTypes = {
  label: _propTypes.default.node.isRequired,
  className: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  enableFormatting: _propTypes.default.bool,
  content: _propTypes.default.string,
  id: _propTypes.default.string,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func.isRequired,
  onFocus: _propTypes.default.func,
  onInput: _propTypes.default.func,
  onKeyDown: _propTypes.default.func,
  onKeyUp: _propTypes.default.func,
  onMouseUp: _propTypes.default.func,
  onPaste: _propTypes.default.func,
  placeholder: _propTypes.default.string
}, _class2.defaultProps = {
  className: '',
  disabled: false,
  enableFormatting: true,
  onBlur: Function.prototype,
  onFocus: Function.prototype,
  onInput: Function.prototype,
  onKeyDown: Function.prototype,
  content: void 0,
  id: void 0,
  onKeyUp: void 0,
  onMouseUp: void 0,
  onPaste: void 0,
  placeholder: void 0
}, _temp)) || _class);
exports.default = ContentEditable;