"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf4 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _omit = _interopRequireDefault(require("lodash/fp/omit"));

var _uiIcons = require("@instructure/ui-icons");

var _uiThemeable = require("@instructure/ui-themeable");

var _uiOverlays = require("@instructure/ui-overlays");

var _uiButtons = require("@instructure/ui-buttons");

var _uiA11y = require("@instructure/ui-a11y");

var _FocusGroup = _interopRequireDefault(require("../../../components/FocusGroup"));

var _theme = _interopRequireDefault(require("./theme"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec, _class, _class2, _temp, _dec2, _class3, _class4, _temp2;

var styles = {
  componentId: 'fleTO',
  template: function template(theme) {
    return "\n\n.fleTO_bPQy{padding-top:".concat(theme.lockChoiceButtonPadding || 'inherit', "}");
  },
  'lockChoiceButton': 'fleTO_bPQy'
};
// Unnecessary Component used to circumvent instui's bugs
// with Tooltip & Button interaction
var IconButton = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(IconButton, _Component);

  function IconButton() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, IconButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf4.default)(IconButton)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.handleClick = function (event) {
      event.preventDefault();

      _this.props.onToggle(_this.props.name);
    };

    return _this;
  }

  (0, _createClass2.default)(IconButton, [{
    key: "render",
    value: function render() {
      var props = (0, _omit.default)(['children', 'onToggle'], this.props);
      return _react.default.createElement(_uiButtons.Button, Object.assign({}, props, {
        onClick: this.handleClick,
        variant: "icon"
      }), this.props.children);
    }
  }]);
  IconButton.displayName = "IconButton";
  return IconButton;
}(_react.Component), _class2.propTypes = {
  name: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  onToggle: _propTypes.default.func,
  children: _propTypes.default.node.isRequired
}, _class2.defaultProps = {
  name: void 0,
  onToggle: void 0
}, _temp)) || _class);

var _ref =
/*#__PURE__*/
_react.default.createElement(_uiIcons.IconLockLine, null);

var _ref2 =
/*#__PURE__*/
_react.default.createElement(_uiIcons.IconUnlockLine, null);

var LockChoiceButton = (_dec2 = (0, _uiThemeable.themeable)(_theme.default, styles), _dec2(_class3 = (_temp2 = _class4 =
/*#__PURE__*/
function (_Component2) {
  (0, _inherits2.default)(LockChoiceButton, _Component2);

  function LockChoiceButton() {
    var _getPrototypeOf3;

    var _this2;

    (0, _classCallCheck2.default)(this, LockChoiceButton);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf3 = (0, _getPrototypeOf4.default)(LockChoiceButton)).call.apply(_getPrototypeOf3, [this].concat(args)));
    _this2.focusGroup = null;

    _this2.handleFocusGroupRef = function (node) {
      _this2.focusGroup = node;
    };

    return _this2;
  }

  (0, _createClass2.default)(LockChoiceButton, [{
    key: "focus",
    // ================
    //   PUBLIC UTILS
    // ================
    value: function focus() {
      this.focusGroup.focusLast();
    } // ============
    //   HANDLERS
    // ============

  }, {
    key: "render",
    // ===========
    //   RENDERS
    // ===========
    value: function render() {
      var _this$props = this.props,
          isLocked = _this$props.isLocked,
          choiceId = _this$props.choiceId;
      var icon = isLocked ? _ref : _ref2;
      var tooltipText = isLocked ? (0, _formatMessage.default)('Unlock Distractor Position') : (0, _formatMessage.default)('Lock Distractor Position');
      return _react.default.createElement(_FocusGroup.default, {
        ref: this.handleFocusGroupRef,
        as: "span",
        asProps: {
          className: styles.lockChoiceButton
        }
      }, _react.default.createElement(_uiOverlays.Tooltip, {
        variant: "inverse",
        ref: this.handleRef,
        name: choiceId,
        onToggle: this.props.onToggle,
        tip: tooltipText,
        placement: "start",
        disabled: this.props.disabled,
        as: IconButton
      }, icon), _react.default.createElement(_uiA11y.ScreenReaderContent, null, this.props.screenReaderText));
    }
  }]);
  LockChoiceButton.displayName = "LockChoiceButton";
  return LockChoiceButton;
}(_react.Component), _class4.propTypes = {
  choiceId: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  disabled: _propTypes.default.bool,
  isLocked: _propTypes.default.bool,
  onToggle: _propTypes.default.func,
  screenReaderText: _propTypes.default.string.isRequired
}, _class4.defaultProps = {
  choiceId: void 0,
  disabled: false,
  isLocked: false,
  onToggle: Function.prototype
}, _temp2)) || _class3);
exports.default = LockChoiceButton;