"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _omit = _interopRequireDefault(require("lodash/omit"));

var _htmlencode = require("htmlencode");

var _uiForms = require("@instructure/ui-forms");

var _extractTextFromHtml = _interopRequireDefault(require("../../../../../util/extractTextFromHtml"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var PlainTextInput =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(PlainTextInput, _Component);

  function PlainTextInput() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, PlainTextInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(PlainTextInput)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.handleChange = function (event) {
      var escaped = (0, _htmlencode.htmlEncode)(event.target.value);

      _this.props.onChange(event, escaped);
    };

    _this.handleRef = function (node) {
      _this.textarea = node;
      _this.props.textareaRef && _this.props.textareaRef(node);
    };

    return _this;
  }

  (0, _createClass2.default)(PlainTextInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.focusOnMount) {
        this.textarea.focus();
      }
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_uiForms.TextArea, Object.assign({
        defaultValue: (0, _extractTextFromHtml.default)(this.props.defaultValue),
        onChange: this.handleChange,
        textareaRef: this.handleRef
      }, (0, _omit.default)(this.props, Object.keys(this.constructor.plainTextInputTypes)), {
        autoGrow: this.context.disableTextAreaAutoGrow ? false : this.props.autoGrow
      }));
    }
  }]);
  PlainTextInput.displayName = "PlainTextInput";
  return PlainTextInput;
}(_react.Component);

exports.default = PlainTextInput;
PlainTextInput.plainTextInputTypes = {
  defaultValue: _propTypes.default.string,
  focusOnMount: _propTypes.default.bool,
  onChange: _propTypes.default.func,
  textareaRef: _propTypes.default.func
};
PlainTextInput.propTypes = _objectSpread({}, _uiForms.TextArea.propTypes, {}, PlainTextInput.plainTextInputTypes);
PlainTextInput.defaultProps = _objectSpread({}, _uiForms.TextArea.defaultProps, {
  defaultValue: void 0,
  focusOnMount: false,
  onChange: Function.prototype,
  textareaRef: Function.prototype
});
PlainTextInput.contextTypes = {
  disableTextAreaAutoGrow: _propTypes.default.bool
};