"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Take = _interopRequireDefault(require("../Take"));

/**
---
category: Essay
---
  Essay Show component

  ```jsx_example
  <SettingsSwitcher locales={LOCALES}>
    <EssayShow
      itemBody="Why did the Roman Empire fall?"
      userResponse={{ value: 'This is some text' }}
      interactionData={{
        rce: true,
        spellCheck: true,
        wordCount: true,
        wordLimitEnabled: true,
        wordLimitMax: 10,
        wordLimitMin: 1,
        notes: 'Teachers grading notes'
      }}
    />
  </SettingsSwitcher>
  ```
**/
var EssayShow =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(EssayShow, _Component);

  function EssayShow() {
    (0, _classCallCheck2.default)(this, EssayShow);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(EssayShow).apply(this, arguments));
  }

  (0, _createClass2.default)(EssayShow, [{
    key: "render",
    value: function render() {
      return _react.default.createElement(_Take.default, {
        interactionData: this.props.interactionData,
        itemBody: this.props.itemBody,
        userResponse: this.props.userResponse,
        readOnly: true
      });
    }
  }]);
  EssayShow.displayName = "EssayShow";
  return EssayShow;
}(_react.Component);

exports.default = EssayShow;
EssayShow.propTypes = {
  interactionData: _propTypes.default.object.isRequired,
  itemBody: _propTypes.default.string.isRequired,
  userResponse: _propTypes.default.object // FIXME: this should be scoringData

};
EssayShow.defaultProps = {
  userResponse: void 0
};