"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = generator;

var _uiColorUtils = require("@instructure/ui-color-utils");

function generator(_ref) {
  var spacing = _ref.spacing,
      colors = _ref.colors,
      borders = _ref.borders;
  return {
    entryWrapperPadding: spacing.xSmall,
    focusBorderColor: colors.brand,
    focusOutlineColor: (0, _uiColorUtils.alpha)(colors.brand, 50),
    userResponsePaddingLeft: spacing.small,
    previewBoxColor: colors.ash,
    previewBoxBorderWidth: borders.widthSmall,
    fileIconColor: colors.slate,
    spinnerColor: colors.porcelain,
    removeButtonMargin: spacing.small
  };
}

generator.canvas = function (variables) {
  return {
    focusBorderColor: variables['ic-brand-primary'],
    focusOutlineColor: (0, _uiColorUtils.alpha)(variables['ic-brand-primary'], 50)
  };
};