"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _uuid = require("uuid");

var _striptags = _interopRequireDefault(require("striptags"));

var _findIndex = _interopRequireDefault(require("lodash/findIndex"));

var _get = _interopRequireDefault(require("lodash/get"));

var _uiForms = require("@instructure/ui-forms");

var _uiFormField = require("@instructure/ui-form-field");

var _uiA11y = require("@instructure/ui-a11y");

var _uiThemeable = require("@instructure/ui-themeable");

var _ChoiceInput = _interopRequireDefault(require("../../../../../common/edit/components/ChoiceInput"));

var _ChoiceInputWrapper = _interopRequireDefault(require("../../../../../common/edit/components/ChoiceInputWrapper"));

var _Errors = _interopRequireDefault(require("../../../../../common/edit/components/Errors"));

var _Footer = _interopRequireDefault(require("../../../../../common/edit/components/Footer"));

var _theme = _interopRequireDefault(require("./theme"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'eoeyK',
  template: function template(theme) {
    return "\n\n.eoeyK_fhgb{margin-top:-0.3rem}";
  },
  'choiceWrapperAdjustment': 'eoeyK_fhgb'
};
var BlankChoices = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(BlankChoices, _Component);

  function BlankChoices() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, BlankChoices);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(BlankChoices)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this._timeouts = [];
    _this.choiceInputRefs = [];

    _this.updateScoringData = function (value) {
      var correctChoice = _this.props.choices.find(function (c) {
        return c.id === value;
      });

      _this.props.updateScoringDataForBlank({
        scoringData: {
          value: value,
          blankText: correctChoice ? correctChoice.itemBody : ''
        }
      });
    };

    _this.updateChoice = function (choiceId, e) {
      var choice = _this.props.choices.find(function (c) {
        return c.id === choiceId;
      });

      var mods = _this.__updateChoices(choice, e);

      _this.props.updateBlank({
        choices: mods
      }); // if updating correct answer, also update scoringData


      if (choiceId === _this.props.scoringDataForBlank.value) {
        _this.props.updateScoringDataForBlank({
          scoringData: {
            value: choiceId,
            blankText: e.target.value
          }
        });
      }
    };

    _this.handleAddChoice = function () {
      var nextPosition = Math.max.apply(Math, [0].concat((0, _toConsumableArray2.default)(_this.props.choices.map(function (i) {
        return i.position;
      })))) + 1;

      var mods = _this.props.choices.concat({
        id: (0, _uuid.v4)(),
        position: nextPosition,
        itemBody: ''
      });

      _this.props.updateBlank({
        choices: mods
      });

      _this.props.notifyScreenreader((0, _formatMessage.default)('Added additional choice.'));

      _this._timeouts = _this._timeouts.concat(setTimeout(function () {
        var lastInputIndex = _this.props.choices.length - 1;

        _this.choiceInputRefs[lastInputIndex].focusOnAnswerInput();
      }));
    };

    _this.handleRemoveChoice = function (choiceId) {
      var mods = _this.props.choices.filter(function (choice) {
        return choice.id !== choiceId;
      });

      if (choiceId === _this.props.scoringDataForBlank.value) {
        _this.updateScoringData(null);
      }

      _this.props.updateBlank({
        choices: mods
      });

      _this.props.notifyScreenreader((0, _formatMessage.default)('Removed additional choice.'));

      var indexToRemove = (0, _findIndex.default)(_this.props.choices, function (li) {
        return li.id === choiceId;
      });
      _this._timeouts = _this._timeouts.concat(setTimeout(function () {
        var choicesLength = _this.props.choices.length;

        if (choicesLength === 1) {
          _this.choiceInputRefs[0].focusOnAnswerInput();
        } else if (choicesLength === indexToRemove) {
          _this.choiceInputRefs[indexToRemove - 1].focusOnRemoveChoice();
        } else {
          _this.choiceInputRefs[indexToRemove].focusOnRemoveChoice();
        }
      }));
    };

    _this.handleChoiceChange = function (event) {
      _this.updateScoringData(event.target.value);
    };

    _this.renderChoice = function (choice, choiceIndex) {
      var onlyChoice = _this.props.choices.length === 1;
      var errors = (0, _get.default)(_this.props.interactionDataErrors, ['choices', choiceIndex, 'itemBody'], []).map(function (error) {
        return {
          text: error,
          type: 'error'
        };
      });
      var isChecked = _this.props.scoringDataForBlank.value === choice.id;
      var labelText = choice.itemBody.trim() === '' ? (0, _formatMessage.default)('Radio button for blank answer') : (0, _formatMessage.default)('Radio button for answer { answer }', {
        answer: (0, _striptags.default)(choice.itemBody)
      });
      return _react.default.createElement("div", {
        key: choice.id,
        className: styles.choiceWrapperAdjustment
      }, _react.default.createElement(_ChoiceInputWrapper.default, {
        choiceInput: _react.default.createElement(_ChoiceInput.default, {
          id: choice.id,
          itemBody: choice.itemBody,
          errors: errors,
          onInputChange: _this.updateChoice,
          onModalClose: _this.props.onModalClose,
          onModalOpen: _this.props.onModalOpen,
          onRemoveChoice: _this.handleRemoveChoice,
          ref: function ref(node) {
            _this.choiceInputRefs[choiceIndex] = node;
          },
          focusOnMount: false,
          shouldRenderRemoveChoice: !onlyChoice && !_this.props.disabled,
          removeButtonScreenReaderText: (0, _formatMessage.default)('Remove Answer: {choice}', {
            choice: choice.itemBody
          }),
          noRCE: true,
          notifyScreenreader: _this.props.notifyScreenreader
        }),
        customInput: _react.default.createElement(_uiForms.RadioInput, {
          onChange: _this.handleChoiceChange,
          name: "radio_for_".concat(_this.props.blankName) // eslint-disable-line react/jsx-no-literals
          ,
          label: _react.default.createElement(_uiA11y.ScreenReaderContent, null, labelText),
          value: choice.id,
          checked: isChecked
        })
      }));
    };

    return _this;
  }

  (0, _createClass2.default)(BlankChoices, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._timeouts.forEach(clearTimeout);
    } // ===========
    //   HANDLERS
    // ===========

  }, {
    key: "__updateChoices",
    value: function __updateChoices(choice, e) {
      var modifiedAnswer = Object.assign({}, choice, {
        itemBody: e.target.value
      });
      var indexToModify = (0, _findIndex.default)(this.props.choices, function (li) {
        return li.id === choice.id;
      });
      return Object.assign([], this.props.choices, (0, _defineProperty2.default)({}, indexToModify, modifiedAnswer));
    }
  }, {
    key: "render",
    value: function render() {
      this.choiceInputRefs = [];
      return _react.default.createElement(_Errors.default, {
        errorList: this.props.errors
      }, _react.default.createElement(_uiFormField.FormFieldGroup, {
        rowSpacing: "small",
        description: (0, _formatMessage.default)('Possible Choices'),
        name: "choices_for_".concat(this.props.blankName) // eslint-disable-line react/jsx-no-literals

      }, this.props.choices.map(this.renderChoice)), !this.props.disabled && _react.default.createElement(_Footer.default, {
        onCreateChoice: this.handleAddChoice
      }));
    }
  }]);
  BlankChoices.displayName = "BlankChoices";
  return BlankChoices;
}(_react.Component), _class2.propTypes = {
  blankName: _propTypes.default.string.isRequired,
  choices: _propTypes.default.array.isRequired,
  disabled: _propTypes.default.bool,
  errors: _propTypes.default.array,
  interactionDataErrors: _propTypes.default.object,
  notifyScreenreader: _propTypes.default.func.isRequired,
  onModalClose: _propTypes.default.func,
  onModalOpen: _propTypes.default.func,
  scoringDataForBlank: _propTypes.default.object.isRequired,
  updateBlank: _propTypes.default.func.isRequired,
  updateScoringDataForBlank: _propTypes.default.func.isRequired
}, _class2.defaultProps = {
  disabled: false,
  errors: void 0,
  interactionDataErrors: void 0,
  onModalClose: void 0,
  onModalOpen: void 0
}, _temp)) || _class);
exports.default = BlankChoices;