"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setupDefaultChoices = setupDefaultChoices;
exports.setupDefaultEditDistance = setupDefaultEditDistance;
exports.setupDefaultSpecifiedAnswers = setupDefaultSpecifiedAnswers;

var _uuid = require("uuid");

function setupDefaultChoices(blankText) {
  var defaultChoices = {
    scoringData: {
      value: null,
      blankText: blankText
    },
    choices: [{
      id: (0, _uuid.v4)(),
      position: 1,
      itemBody: ''
    }, {
      id: (0, _uuid.v4)(),
      position: 2,
      itemBody: ''
    }, {
      id: (0, _uuid.v4)(),
      position: 3,
      itemBody: ''
    }]
  };
  var choice = defaultChoices.choices.find(function (choice) {
    return choice.position === 1;
  });
  choice.itemBody = blankText;
  defaultChoices.scoringData.value = choice.id;
  return defaultChoices;
}

function setupDefaultEditDistance(blankText) {
  return {
    value: blankText,
    editDistance: 1,
    ignoreCase: false,
    blankText: blankText
  };
}

function setupDefaultSpecifiedAnswers(blankText) {
  return {
    value: [blankText, ''],
    blankText: blankText
  };
}