"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectHash = _interopRequireDefault(require("object-hash"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var entries = ['Triassic', 'Jurassic', 'Cretaceous'];
var labelProperties = {
  topLabel: 'Earliest',
  bottomLabel: 'Latest'
};

function exampleLabel(properties) {
  if (!properties) return 'Responses hidden';
  var enabledProperties = Object.keys(properties).filter(function (prop) {
    return properties[prop] && !labelProperties[prop];
  });
  return enabledProperties.length ? "Ordering Result (".concat(enabledProperties.join(', '), ")") : 'Ordering Result';
}

var _default = {
  propValues: {
    ordering: [[0, 1, 2], // correct
    [0, 2, 1], // partially correct
    [1, 2, 0], // incorrect
    null // responses hidden
    ],
    properties: [_objectSpread({
      displayAnswersParagraph: false,
      includeLabels: false
    }, labelProperties), _objectSpread({
      displayAnswersParagraph: false,
      includeLabels: true
    }, labelProperties), _objectSpread({
      displayAnswersParagraph: true,
      includeLabels: false
    }, labelProperties), _objectSpread({
      displayAnswersParagraph: true,
      includeLabels: true
    }, labelProperties), _objectSpread({
      hideChoices: true,
      includeLabels: true
    }, labelProperties), _objectSpread({
      hideCorrect: true,
      includeLabels: true
    }, labelProperties), _objectSpread({
      hideChoices: true,
      hideCorrect: true,
      includeLabels: true
    }, labelProperties), {}]
  },
  getComponentProps: function getComponentProps(props) {
    var ordering = props.ordering,
        properties = props.properties;
    var hasProperties = Object.keys(properties).length > 0;
    var ids = entries.map(_objectHash.default.MD5);
    var choices = ids.reduce(function (obj, id, index) {
      var itemBody = entries[index];
      return _objectSpread({}, obj, (0, _defineProperty2.default)({}, id, {
        id: id,
        itemBody: itemBody
      }));
    }, {});
    var scoredData;

    if (ordering && hasProperties) {
      var showChoices = !properties.hideChoices;
      var showCorrect = !properties.hideCorrect;
      scoredData = {
        value: ordering.map(function (position, index) {
          return {
            userResponded: showChoices ? ids[position] : void 0,
            value: showCorrect ? ids[index] : void 0,
            resultScore: showCorrect ? position === index ? 1 : 0 : void 0
          };
        })
      };
    } else {
      scoredData = {
        value: null
      };
    }

    return {
      itemBody: exampleLabel(properties),
      interactionData: {
        choices: choices
      },
      scoredData: scoredData
    };
  },
  // Only show 1 example with { scoredData: { value: null } }
  filter: function filter(props) {
    var ordering = props.ordering,
        properties = props.properties;
    var hasProperties = Object.keys(properties).length > 0;
    return !ordering && hasProperties || ordering && !hasProperties;
  }
};
exports.default = _default;