"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = require("lodash");

var _uiElements = require("@instructure/ui-elements");

var _uiThemeable = require("@instructure/ui-themeable");

var _Edit = _interopRequireDefault(require("../Edit"));

var _Show = _interopRequireDefault(require("../Show"));

var _Take = _interopRequireDefault(require("../Take"));

var _Result = _interopRequireDefault(require("../Result"));

var _defaultTheme = _interopRequireDefault(require("../../common/example/defaultTheme"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'RokRl',
  template: function template(theme) {
    return "\n\n.egxol_dXOl{flex:1;padding:".concat(theme.panelPadding || 'inherit', "}\n\n.egxol_qOas{display:flex}");
  },
  'panel': 'egxol_dXOl',
  'row': 'egxol_qOas'
};

var _ref =
/*#__PURE__*/
_react.default.createElement(_uiElements.Heading, {
  level: "h2"
}, "Edit");

var _ref2 =
/*#__PURE__*/
_react.default.createElement(_uiElements.Heading, {
  level: "h2"
}, "Show");

var _ref3 =
/*#__PURE__*/
_react.default.createElement(_uiElements.Heading, {
  level: "h2"
}, "Take");

var _ref4 =
/*#__PURE__*/
_react.default.createElement(_uiElements.Heading, {
  level: "h2"
}, "Result");

var TrueFalseExample = (
/**
---
category: TrueFalse
---
  TrueFalse Example.

  ```jsx_example
    <SettingsSwitcher locales={LOCALES}>
      <TrueFalseExample />
    </SettingsSwitcher>
  ```
**/
_dec = (0, _uiThemeable.themeable)(_defaultTheme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(TrueFalseExample, _Component);

  function TrueFalseExample(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TrueFalseExample);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(TrueFalseExample).call(this));

    _this.handleChangeItemState = function (itemState) {
      var newState = {};

      if (itemState.scoringData) {
        newState.scoredData = _this.transformScoredData(itemState.scoringData);
        newState.userResponse = _this.transformScoredData(itemState.scoringData);
      }

      if (itemState.interactionData) {
        newState.takeInteractionData = _this.transformTakeInteractionData(itemState.interactionData);
      }

      var updatedState = Object.assign({}, itemState, newState);

      _this.setState(updatedState);
    };

    _this.handleResponseUpdate = function (userResponse) {
      var stateUserResponse = {
        value: userResponse
      };

      _this.setState({
        userResponse: stateUserResponse,
        scoredData: _this.transformScoredData(_this.state.scoringData, stateUserResponse)
      });
    };

    _this.state = {};

    if (props.useDefaultData) {
      Object.assign(_this.state, {
        itemBody: 'The sun is a star',
        interactionData: {
          trueChoice: 'True',
          falseChoice: 'False'
        },
        scoringData: {
          value: true
        },
        scoredData: {},
        userResponse: {}
      });
      _this.state.scoredData = _this.transformScoredData(_this.state.scoringData);
      _this.state.takeInteractionData = _this.transformTakeInteractionData(_this.state.interactionData);
    }

    return _this;
  }

  (0, _createClass2.default)(TrueFalseExample, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // eslint-disable-next-line react/no-did-mount-set-state
      this.setState({
        scoredData: this.transformScoredData(this.state.scoringData)
      });
    }
    /**
     * Normally, this should be calling a service
     */

  }, {
    key: "transformScoredData",
    value: function transformScoredData(scoringData) {
      var userResponse = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.state.userResponse;
      return {
        correct: scoringData.value === userResponse.value,
        value: {
          true: {
            resultScore: scoringData.value ? 1 : 0,
            userResponded: userResponse.value === true
          },
          false: {
            resultScore: scoringData.value ? 0 : 1,
            userResponded: userResponse.value === false
          }
        }
      };
    }
    /**
     * Normally, this should be calling a service
     */

  }, {
    key: "transformTakeInteractionData",
    value: function transformTakeInteractionData(interactionData) {
      return (0, _lodash.cloneDeep)(interactionData);
    }
  }, {
    key: "renderEdit",
    value: function renderEdit() {
      return _react.default.createElement("div", {
        title: "edit"
      }, _ref, _react.default.createElement(_Edit.default, {
        changeItemState: this.handleChangeItemState,
        interactionData: this.state.interactionData,
        itemBody: this.state.itemBody,
        itemId: this.state.itemId,
        properties: this.state.properties,
        scoringData: this.state.scoringData
      }));
    }
  }, {
    key: "renderShow",
    value: function renderShow() {
      return _react.default.createElement("div", {
        title: "show"
      }, _ref2, _react.default.createElement(_Show.default, {
        interactionData: this.state.interactionData,
        itemBody: this.state.itemBody,
        itemId: this.state.itemId,
        properties: this.state.properties,
        scoringData: this.state.scoringData
      }));
    }
  }, {
    key: "renderTake",
    value: function renderTake() {
      return _react.default.createElement("div", {
        title: "take"
      }, _ref3, _react.default.createElement(_Take.default, {
        interactionData: this.state.takeInteractionData,
        itemBody: this.state.itemBody,
        userResponse: this.state.userResponse,
        handleResponseUpdate: this.handleResponseUpdate
      }));
    } // FIXME: the props should be scoredData here

  }, {
    key: "renderResult",
    value: function renderResult() {
      return _react.default.createElement("div", {
        title: "result"
      }, _ref4, _react.default.createElement(_Result.default, {
        interactionData: this.state.takeInteractionData,
        itemBody: this.state.itemBody,
        userResponse: this.state.userResponse,
        scoredData: this.state.scoredData
      }));
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", null, _react.default.createElement("div", {
        className: styles.row
      }, _react.default.createElement("div", {
        className: styles.panel
      }, this.renderEdit()), _react.default.createElement("div", {
        className: styles.panel
      }, this.renderShow())), _react.default.createElement("div", {
        className: styles.row
      }, _react.default.createElement("div", {
        className: styles.panel
      }, this.renderTake()), _react.default.createElement("div", {
        className: styles.panel
      }, this.renderResult())));
    }
  }]);
  TrueFalseExample.displayName = "TrueFalseExample";
  return TrueFalseExample;
}(_react.Component), _class2.propTypes = {
  useDefaultData: _propTypes.default.bool
}, _class2.defaultProps = {
  useDefaultData: true
}, _temp)) || _class);
exports.default = TrueFalseExample;