"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));

var _react = _interopRequireDefault(require("react"));

var _instructureValidations = require("instructure-validations");

var _uiElements = require("@instructure/ui-elements");

var _InteractionType2 = _interopRequireDefault(require("../InteractionType"));

var _interaction_slugs = require("../../interaction_slugs");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var FileUploadInteractionType =
/*#__PURE__*/
function (_InteractionType) {
  (0, _inherits2.default)(FileUploadInteractionType, _InteractionType);

  function FileUploadInteractionType(obj) {
    var _this;

    (0, _classCallCheck2.default)(this, FileUploadInteractionType);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(FileUploadInteractionType).call(this));
    _this.slug = _interaction_slugs.FILE_UPLOAD_SLUG;
    _this.translatedName = (0, _formatMessage.default)('File Upload');
    _this.isSubjective = true;
    _this.defaultProperties = {
      restrictTypes: false
    };

    _this.getDefaultScoringData = function () {
      return {
        value: ''
      };
    };

    _this.getDefaultInteractionData = function () {
      return {
        restrictCount: false,
        filesCount: 1
      };
    };

    _this.getRenderedResponse = function (responseValue, interactionData) {
      return _react.default.createElement(_uiElements.Text, {
        color: "primary"
      }, responseValue.map(function (value) {
        return value.name;
      }).join(', '));
    };

    (0, _get2.default)((0, _getPrototypeOf2.default)(FileUploadInteractionType.prototype), "initializeProps", (0, _assertThisInitialized2.default)(_this)).call((0, _assertThisInitialized2.default)(_this), obj);
    return _this;
  }

  (0, _createClass2.default)(FileUploadInteractionType, [{
    key: "getDefaultUserResponse",
    value: function getDefaultUserResponse() {
      return {
        value: []
      };
    }
  }, {
    key: "hasResponse",
    value: function hasResponse(resp) {
      return resp.length > 0;
    }
  }]);
  return FileUploadInteractionType;
}(_InteractionType2.default);

exports.default = FileUploadInteractionType;

FileUploadInteractionType.validations = function () {
  var data = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  var properties = data.properties || {};
  var interactionData = data.interactionData || {};
  var restrictTypes = properties.restrictTypes;
  var restrictCount = interactionData.restrictCount;
  return {
    properties: {
      allowedTypes: restrictTypes ? [(0, _instructureValidations.rule)('fileAccept', {
        message: (0, _formatMessage.default)('Invalid file type restriction')
      })] : []
    },
    interactionData: {
      filesCount: restrictCount ? [(0, _instructureValidations.rule)('numeric', {
        min: 1
      })] : []
    }
  };
};